import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


class ProducteurConsommateur2 extends JFrame 
{  
   private Article article = new Article();
   private Producteur producteur = new Producteur();
   private Consommateur consommateur = new Consommateur();
   
   private MyPanel panel = new MyPanel();
   
   private int nbTours=8;

   
   private void temporisationAleatoire()
   {
      try { Thread.currentThread().sleep((long)(Math.random()*2000)); }
      catch (InterruptedException e) { } 
   }
   
   
   class Article
   {
      private int numero;
      private boolean available;

      public synchronized void setNumero(int n) 
      {
	 if (available)
	 {
	    try { wait(); }
	    catch (InterruptedException e) { System.out.println(e); }
	  }
	 numero=n;
	 available=true;
	 notify();
      }

      public synchronized int getNumero() 
      { 
	 if (! available)
	 {
	    try { wait(); }
	    catch (InterruptedException e) { System.out.println(e); }
	  }
	 int n=numero;
	 available=false;
	 notify();
	 return n;
      } 
   }
   

   class Producteur extends Thread
   {
      public void run()
      {
	 for (int i=0; i<nbTours; i++) 
	 {
	    article.setNumero(i);
	    panel.afficher("Producteur produit " + i);
	    temporisationAleatoire();
	 }
	  panel.afficher("Producteur a termine");
      }
   }


   class Consommateur extends Thread
   {
      public void run()
      {
	 for (int i=0; i<nbTours; i++) 
	 {
	    int v = article.getNumero();
	    panel.afficher("Consommateur consomme " + v);
	    temporisationAleatoire();
	 }
	  panel.afficher("Consommateur a termine");
      }
   }


   class MyPanel extends JPanel
   {
      private JTextArea a = new JTextArea(20,30);
      private JButton go = new JButton("go");

      private void afficher(String s) { a.append(s + "\n"); }


      public MyPanel()
      {
	 add(new JScrollPane(a));
	 add(go);
	 go.addActionListener(new ActionListener()
	    {
	       public void actionPerformed(ActionEvent e)
	       {
		  producteur.start();
		  consommateur.start();
	       }
	    });
      }
   }
   

   public ProducteurConsommateur2()
   {  
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      
      setTitle("Producteur Consommateur 2");
      setSize(d.width/2,d.height/2);
      setLocation(d.width/4,d.height/4);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      setContentPane(panel);
      setVisible(true);
   }
   
   public static void main(String[] args)
   {
      new ProducteurConsommateur2();
   }
}
