import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class TransfertBank2 extends JFrame 
{  
   private Bank bank; 
   private Banquier[] banquiers;
   
   private MyPanel panel = new MyPanel();
   
   private int nbComptes=5;
   private int nbBanquiers=15;
   private int nbVirements=500;
   
   
   private void tempsRepos()
   {
      int rand = (int)(Math.random()*1000);
      for (int i=0; i<rand; i++) ;
   }
      
   
    private void tempsTransaction()
   {
      int rand = (int)(Math.random()*1000);
      for (int i=0; i<rand; i++) ;
   }

   class Bank
   {
      private int nbComptes;
      private int[] comptes;
      private int nbTransactions;
      private long sommeTransactions;
      
      public Bank(int nb)
      {
	 nbComptes=nb;
	 comptes = new int[nbComptes];
      }
      
      public int getNbComptes() { return nbComptes; }
      

      public synchronized void virement(int from, int to, int valeur)
      {
	 if (from == to) return;
	 int val1 = comptes[from];
	 int val2 = comptes[to];
	 tempsTransaction();
	 comptes[from] =  val1 - valeur;
	 comptes[to] = val2 + valeur;
	 nbTransactions++;
	 sommeTransactions += valeur;
	 if (nbTransactions % 1000 == 0) panel.afficher("" + this);
      }

      /*public synchronized void virement(int from, int to, int valeur)
      {
	 comptes[from] -=valeur;
	 tempsTransaction();
	 comptes[to] += valeur;
	 nbTransactions++;
	 sommeTransactions += valeur;
	 if (nbTransactions % 1000 == 0) panel.afficher("" + this);
	    }*/

      public String toString()
      {
	 int somme=0;
	 for (int i=0; i<comptes.length; i++) somme+=comptes[i];
	 return "Transactions : " + sommeTransactions + " ; somme comptes : " + somme;
      }
   }
   

   class Banquier extends Thread
   {
      private int id;

      public Banquier(int i) { id=i; }
      
      public void run()
      {
	 for (int i=0; i<nbVirements; i++)
	 {
	    int from = (int)(bank.getNbComptes()*Math.random());
	    int to = (int)(bank.getNbComptes()*Math.random());
	    int valeur = (int)(100*Math.random());
	    bank.virement(from,to,valeur);
	    tempsRepos();
	 }
	 panel.afficher("Banquier " + id + " a termine ");
	 panel.afficher("***" + bank);
      }
   }


   class MyPanel extends JPanel
   {
      private JTextArea a = new JTextArea(20,30);
      private JButton go = new JButton("go");

      private void afficher(String s) { a.append(s + "\n"); }


      public MyPanel()
      {
	 add(new JScrollPane(a));
	 add(go);
	 go.addActionListener(new ActionListener()
	    {
	       public void actionPerformed(ActionEvent e)
	       {
		  bank = new Bank(nbComptes);
		  banquiers = new Banquier[nbBanquiers];
		  for (int i=0; i<banquiers.length; i++) banquiers[i] = new Banquier(i);
		  for (int i=0; i<banquiers.length; i++) banquiers[i].start();
	       }
	    });
      }
   }
   

   public TransfertBank2()
   {  
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      
      setTitle("Transfert bank 2");
      setSize(d.width/2,d.height/2);
      setLocation(d.width/4,d.height/4);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      setContentPane(panel);
      setVisible(true);
   }
   
   public static void main(String[] args)
   {
      new TransfertBank2();
   }
}
